#ifndef F_CPU
#define F_CPU 16000000L
#endif
#include <avr/io.h>
#include <util/delay.h>
#define BIT_COUNT 4
#define BIT_RESET 5
#define BIT_DS0 0
#define BIT_DS1 1
#define BIT_SHCP 2
#define BIT_STCP 3 
void Display(uint8_t data);
main()
{
	uint8_t dataDS0[8];
	uint8_t dataDS1[8];
	uint8_t mydelay = 0;
	dataDS0[0] = 0b01111111;
	dataDS0[1] = 0b00000000;
	dataDS0[2] = 0b00000000;
	dataDS0[3] = 0b01111111;
	dataDS0[4] = 0b00000000;
	dataDS0[5] = 0b00000000;
	dataDS0[6] = 0b00000000;
	dataDS0[7] = 0b00000000;

	dataDS1[0] = 0b00000000;
	dataDS1[1] = 0b00000000;
	dataDS1[2] = 0b00000000;
	dataDS1[3] = 0b01011111;
	dataDS1[4] = 0b00000000;
	dataDS1[5] = 0b00000000;
	dataDS1[6] = 0b00000000;
	dataDS1[7] = 0b00000000;
	uint8_t count = 0;
	uint8_t modDS0 = 0;
    PORTB = 0b00000000;  // กำหนดลอจิกขา PD7..0 เป็น 0
    DDRB  = 0b00111111;
	PORTB = 0b00000000;  // กำหนดให้ขา PD3 ทำหน้าที่เอาท์พุท
	PORTB &= (~(1<<BIT_COUNT)) ;
	PORTB |= 1<<BIT_RESET ;
	PORTB &= ~((1<<BIT_RESET)); 
	PORTB &= ~(1<<BIT_DS0);
	PORTB &= ~(1<<BIT_DS1);	
	PORTB &= ~(1<< BIT_SHCP);
	//PORTB |= 1<< BIT_DS0;
	//PORTB |= 1<< BIT_DS1;
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);	
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	//PORTB |= 1<<BIT_DS1;
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);

	PORTB |= 1 << BIT_STCP;
	PORTB &= ~(1 << BIT_STCP);
	//endshift

    while (1)
    {
		//_delay_ms(10);
		
		
		if (count==0b11111111 )
		{
			mydelay ++;
			if (mydelay==0b00000011)
			{
				if (dataDS0[3] == 0)
				{
					dataDS0[3] = 0b11111111;
				}
			 	dataDS0[3] >>= 1;
				mydelay = 0;
			}
		}
		//_delay_ms(1);		
		DisplayDS0(0b00000000,BIT_DS0);
		DisplayDS0(0b00000000,BIT_DS1);
		modDS0 = count%8;
		
		if (modDS0==0)
		{
			PORTB |= 1<<BIT_RESET;
			PORTB &= ~(1<<BIT_RESET);
		}
		else
		{
			PORTB |= 1<< BIT_COUNT ;
			//_delay_ms(1);
			PORTB &= ~(1<< BIT_COUNT) ;
	
		}
		DisplayDS0(dataDS0[modDS0],BIT_DS0);
		DisplayDS0(dataDS1[modDS0],BIT_DS1);
		count++;          
          
        //_delay_ms(500);
		//PORTB &= ~(1<<BIT_DS0);
				//shift 8 times
		//_delay_ms(10);
		
		//_delay_ms(10);
		//
		//_delay_ms(100);
		//

    }
}
void DisplayDS0(uint8_t data, uint8_t bit_ds)
{
	PORTB &= ~(1<<bit_ds); 
	if (bit_ds-0 > 0)		
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 0));
	else 
		PORTB |= (1<<bit_ds) & (data >> (0 - bit_ds));
	PORTB &= ~(1<< BIT_SHCP);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);
	if (bit_ds-1 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 1));
	else 
		PORTB |= (1<<bit_ds) & (data >> (1 - bit_ds));
	//_delay_ms(1);
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);
	if (bit_ds-2 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 2));
	else 
		PORTB |= (1<<bit_ds) & (data >> (2 - bit_ds));
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);
	if (bit_ds-3 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 3));
	else 
		PORTB |= (1<<bit_ds) & (data >> (3 - bit_ds));
		
	PORTB |= (1<<BIT_SHCP);	
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);	
	if (bit_ds-4 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 4));
	else 
		PORTB |= (1<<bit_ds) & (data >> (4 - bit_ds));
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);	
	if (bit_ds-5 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 5));
	else 
		PORTB |= (1<<bit_ds) & (data >> (5 - bit_ds));
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);
	if (bit_ds-6 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 6));
	else 
		PORTB |= (1<<bit_ds) & (data >> (6 - bit_ds));
	PORTB |= (1<<BIT_SHCP);
	PORTB &= ~(1<< BIT_SHCP);
	PORTB &= ~(1<<bit_ds);
	if (bit_ds-7 > 0)
		PORTB |= (1<<bit_ds) & (data << (bit_ds - 7));
	else 
		PORTB |= (1<<bit_ds) & (data >> (7 - bit_ds));
	//PORTB |= (1<<bit_ds);
	PORTB |= (1<<BIT_SHCP);
	PORTB |= 1 << BIT_STCP;
	PORTB &= ~(1 << BIT_STCP);
}

