class KeyMaker:

    def KeyReader(self): # Read File
        keyfile = open(self.filename,'r')
        self.bpm = float(keyfile.readline())
        self.offset = float(keyfile.readline())
        self.onekeytime = 60.0/self.bpm*4
        all_lines = ("".join(keyfile.readlines())).split(',')
        for x in xrange(len(all_lines)):
            all_lines[x] = all_lines[x].strip()
        return all_lines

    def n_to_xy(self,n): # Change index 1d to 2d
        xy = []
        xy.append(n/4)
        xy.append(n%4)
        return xy
    
    def xy_to_n(self,xy):
        n = xy[0]*4 + xy[1]
        return n
    
    def SplitBlock(self,block):
        #block.replace("\n","")
        #print block
        return block.split()

    def KeyParser(self,all_lines): # Insert key to timeline
        timeline = [[[],[],[],[]],[[],[],[],[]],[[],[],[],[]],[[],[],[],[]]] 
        currentTime = -self.offset
        for x in xrange(len(all_lines)):
            block = self.SplitBlock(all_lines[x])
            #print block
            #print "-----------"
            divkey = float(self.onekeytime)/len(block)
            for r in xrange(len(block)):
                for y in xrange(4):
                    if(block[r][y]!='0'):
                        xy = self.n_to_xy(((r*4)+y)%16)
                        timeline[xy[0]][xy[1]].append(float((divkey*r+currentTime)))
            currentTime += self.onekeytime
        return timeline

    def __init__(self,name): # Initialize value
        self.bpm = 0.0
        self.onekeytime = 0.0
        self.offset = 0.0
        self.filename = name

    def changeFile(self,name): # Change File name
        self.filename = name

#keymaker = KeyMaker("song/connect/connect.txt")
#lines = keymaker.KeyReader()
#print lines
#timeline = keymaker.KeyParser(lines)
#print timeline
